/* Generated by ts-generator ver. 0.0.8 */
/* tslint:disable */

import { Contract, ContractTransaction, EventFilter, Signer } from "ethers";
import { Listener, Provider } from "ethers/providers";
import { Arrayish, BigNumber, BigNumberish, Interface } from "ethers/utils";
import {
  TransactionOverrides,
  TypedEventDescription,
  TypedFunctionDescription
} from ".";

interface RegistryInterface extends Interface {
  functions: {
    balanceOf: TypedFunctionDescription<{
      encode([_owner, _id]: [string, BigNumberish]): string;
    }>;

    balanceOfBatch: TypedFunctionDescription<{
      encode([_owners, _ids]: [string[], BigNumberish[]]): string;
    }>;

    certificateStorage: TypedFunctionDescription<{
      encode([]: [BigNumberish]): string;
    }>;

    claimedBalances: TypedFunctionDescription<{
      encode([,]: [BigNumberish, string]): string;
    }>;

    create: TypedFunctionDescription<{
      encode([_initialSupply, _uri, creator]: [
        BigNumberish,
        string,
        string
      ]): string;
    }>;

    creators: TypedFunctionDescription<{ encode([]: [BigNumberish]): string }>;

    initialize: TypedFunctionDescription<{ encode([]: []): string }>;

    isApprovedForAll: TypedFunctionDescription<{
      encode([_owner, _operator]: [string, string]): string;
    }>;

    mint: TypedFunctionDescription<{
      encode([_id, _to, _quantity]: [
        BigNumberish,
        string,
        BigNumberish
      ]): string;
    }>;

    nonce: TypedFunctionDescription<{ encode([]: []): string }>;

    safeBatchTransferFrom: TypedFunctionDescription<{
      encode([_from, _to, _ids, _values, _data]: [
        string,
        string,
        BigNumberish[],
        BigNumberish[],
        Arrayish
      ]): string;
    }>;

    safeTransferFrom: TypedFunctionDescription<{
      encode([_from, _to, _id, _value, _data]: [
        string,
        string,
        BigNumberish,
        BigNumberish,
        Arrayish
      ]): string;
    }>;

    setApprovalForAll: TypedFunctionDescription<{
      encode([_operator, _approved]: [string, boolean]): string;
    }>;

    setURI: TypedFunctionDescription<{
      encode([_uri, _id]: [string, BigNumberish]): string;
    }>;

    supportsInterface: TypedFunctionDescription<{
      encode([_interfaceId]: [Arrayish]): string;
    }>;

    issue: TypedFunctionDescription<{
      encode([_to, _validityData, _topic, _value, _data]: [
        string,
        Arrayish,
        BigNumberish,
        BigNumberish,
        Arrayish
      ]): string;
    }>;

    safeTransferAndClaimFrom: TypedFunctionDescription<{
      encode([_from, _to, _id, _value, _data, _claimData]: [
        string,
        string,
        BigNumberish,
        BigNumberish,
        Arrayish,
        Arrayish
      ]): string;
    }>;

    safeBatchTransferAndClaimFrom: TypedFunctionDescription<{
      encode([_from, _to, _ids, _values, _data, _claimData]: [
        string,
        string,
        BigNumberish[],
        BigNumberish[],
        Arrayish,
        Arrayish[]
      ]): string;
    }>;

    getCertificate: TypedFunctionDescription<{
      encode([_id]: [BigNumberish]): string;
    }>;

    claimedBalanceOf: TypedFunctionDescription<{
      encode([_owner, _id]: [string, BigNumberish]): string;
    }>;

    totalSupply: TypedFunctionDescription<{ encode([]: []): string }>;

    allCertificateIds: TypedFunctionDescription<{ encode([]: []): string }>;
  };

  events: {
    ApprovalForAll: TypedEventDescription<{
      encodeTopics([_owner, _operator, _approved]: [
        string | null,
        string | null,
        null
      ]): string[];
    }>;

    ClaimBatch: TypedEventDescription<{
      encodeTopics([
        _claimIssuer,
        _claimSubject,
        _topics,
        _ids,
        _values,
        _claimData
      ]: [
        string | null,
        string | null,
        BigNumberish[] | null,
        null,
        null,
        null
      ]): string[];
    }>;

    ClaimSingle: TypedEventDescription<{
      encodeTopics([
        _claimIssuer,
        _claimSubject,
        _topic,
        _id,
        _value,
        _claimData
      ]: [
        string | null,
        string | null,
        BigNumberish | null,
        null,
        null,
        null
      ]): string[];
    }>;

    IssuanceSingle: TypedEventDescription<{
      encodeTopics([_issuer, _topic, _id]: [
        string | null,
        BigNumberish | null,
        null
      ]): string[];
    }>;

    TransferBatch: TypedEventDescription<{
      encodeTopics([_operator, _from, _to, _ids, _values]: [
        string | null,
        string | null,
        string | null,
        null,
        null
      ]): string[];
    }>;

    TransferSingle: TypedEventDescription<{
      encodeTopics([_operator, _from, _to, _id, _value]: [
        string | null,
        string | null,
        string | null,
        null,
        null
      ]): string[];
    }>;

    URI: TypedEventDescription<{
      encodeTopics([_value, _id]: [null, BigNumberish | null]): string[];
    }>;
  };
}

export class Registry extends Contract {
  connect(signerOrProvider: Signer | Provider | string): Registry;
  attach(addressOrName: string): Registry;
  deployed(): Promise<Registry>;

  on(event: EventFilter | string, listener: Listener): Registry;
  once(event: EventFilter | string, listener: Listener): Registry;
  addListener(eventName: EventFilter | string, listener: Listener): Registry;
  removeAllListeners(eventName: EventFilter | string): Registry;
  removeListener(eventName: any, listener: Listener): Registry;

  interface: RegistryInterface;

  functions: {
    balanceOf(_owner: string, _id: BigNumberish): Promise<BigNumber>;

    balanceOfBatch(
      _owners: string[],
      _ids: BigNumberish[]
    ): Promise<BigNumber[]>;

    certificateStorage(
      arg0: BigNumberish
    ): Promise<{
      topic: BigNumber;
      issuer: string;
      validityData: string;
      data: string;
      0: BigNumber;
      1: string;
      2: string;
      3: string;
    }>;

    claimedBalances(arg0: BigNumberish, arg1: string): Promise<BigNumber>;

    create(
      _initialSupply: BigNumberish,
      _uri: string,
      creator: string,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    creators(arg0: BigNumberish): Promise<string>;

    initialize(overrides?: TransactionOverrides): Promise<ContractTransaction>;

    isApprovedForAll(_owner: string, _operator: string): Promise<boolean>;

    mint(
      _id: BigNumberish,
      _to: string,
      _quantity: BigNumberish,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    nonce(): Promise<BigNumber>;

    safeBatchTransferFrom(
      _from: string,
      _to: string,
      _ids: BigNumberish[],
      _values: BigNumberish[],
      _data: Arrayish,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    safeTransferFrom(
      _from: string,
      _to: string,
      _id: BigNumberish,
      _value: BigNumberish,
      _data: Arrayish,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    setApprovalForAll(
      _operator: string,
      _approved: boolean,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    setURI(
      _uri: string,
      _id: BigNumberish,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    supportsInterface(_interfaceId: Arrayish): Promise<boolean>;

    issue(
      _to: string,
      _validityData: Arrayish,
      _topic: BigNumberish,
      _value: BigNumberish,
      _data: Arrayish,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    safeTransferAndClaimFrom(
      _from: string,
      _to: string,
      _id: BigNumberish,
      _value: BigNumberish,
      _data: Arrayish,
      _claimData: Arrayish,
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    safeBatchTransferAndClaimFrom(
      _from: string,
      _to: string,
      _ids: BigNumberish[],
      _values: BigNumberish[],
      _data: Arrayish,
      _claimData: Arrayish[],
      overrides?: TransactionOverrides
    ): Promise<ContractTransaction>;

    getCertificate(
      _id: BigNumberish
    ): Promise<{
      issuer: string;
      topic: BigNumber;
      validityData: string;
      data: string;
      0: string;
      1: BigNumber;
      2: string;
      3: string;
    }>;

    claimedBalanceOf(_owner: string, _id: BigNumberish): Promise<BigNumber>;

    totalSupply(): Promise<BigNumber>;

    allCertificateIds(): Promise<BigNumber[]>;
  };

  balanceOf(_owner: string, _id: BigNumberish): Promise<BigNumber>;

  balanceOfBatch(_owners: string[], _ids: BigNumberish[]): Promise<BigNumber[]>;

  certificateStorage(
    arg0: BigNumberish
  ): Promise<{
    topic: BigNumber;
    issuer: string;
    validityData: string;
    data: string;
    0: BigNumber;
    1: string;
    2: string;
    3: string;
  }>;

  claimedBalances(arg0: BigNumberish, arg1: string): Promise<BigNumber>;

  create(
    _initialSupply: BigNumberish,
    _uri: string,
    creator: string,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  creators(arg0: BigNumberish): Promise<string>;

  initialize(overrides?: TransactionOverrides): Promise<ContractTransaction>;

  isApprovedForAll(_owner: string, _operator: string): Promise<boolean>;

  mint(
    _id: BigNumberish,
    _to: string,
    _quantity: BigNumberish,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  nonce(): Promise<BigNumber>;

  safeBatchTransferFrom(
    _from: string,
    _to: string,
    _ids: BigNumberish[],
    _values: BigNumberish[],
    _data: Arrayish,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  safeTransferFrom(
    _from: string,
    _to: string,
    _id: BigNumberish,
    _value: BigNumberish,
    _data: Arrayish,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  setApprovalForAll(
    _operator: string,
    _approved: boolean,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  setURI(
    _uri: string,
    _id: BigNumberish,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  supportsInterface(_interfaceId: Arrayish): Promise<boolean>;

  issue(
    _to: string,
    _validityData: Arrayish,
    _topic: BigNumberish,
    _value: BigNumberish,
    _data: Arrayish,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  safeTransferAndClaimFrom(
    _from: string,
    _to: string,
    _id: BigNumberish,
    _value: BigNumberish,
    _data: Arrayish,
    _claimData: Arrayish,
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  safeBatchTransferAndClaimFrom(
    _from: string,
    _to: string,
    _ids: BigNumberish[],
    _values: BigNumberish[],
    _data: Arrayish,
    _claimData: Arrayish[],
    overrides?: TransactionOverrides
  ): Promise<ContractTransaction>;

  getCertificate(
    _id: BigNumberish
  ): Promise<{
    issuer: string;
    topic: BigNumber;
    validityData: string;
    data: string;
    0: string;
    1: BigNumber;
    2: string;
    3: string;
  }>;

  claimedBalanceOf(_owner: string, _id: BigNumberish): Promise<BigNumber>;

  totalSupply(): Promise<BigNumber>;

  allCertificateIds(): Promise<BigNumber[]>;

  filters: {
    ApprovalForAll(
      _owner: string | null,
      _operator: string | null,
      _approved: null
    ): EventFilter;

    ClaimBatch(
      _claimIssuer: string | null,
      _claimSubject: string | null,
      _topics: BigNumberish[] | null,
      _ids: null,
      _values: null,
      _claimData: null
    ): EventFilter;

    ClaimSingle(
      _claimIssuer: string | null,
      _claimSubject: string | null,
      _topic: BigNumberish | null,
      _id: null,
      _value: null,
      _claimData: null
    ): EventFilter;

    IssuanceSingle(
      _issuer: string | null,
      _topic: BigNumberish | null,
      _id: null
    ): EventFilter;

    TransferBatch(
      _operator: string | null,
      _from: string | null,
      _to: string | null,
      _ids: null,
      _values: null
    ): EventFilter;

    TransferSingle(
      _operator: string | null,
      _from: string | null,
      _to: string | null,
      _id: null,
      _value: null
    ): EventFilter;

    URI(_value: null, _id: BigNumberish | null): EventFilter;
  };

  estimate: {
    balanceOf(_owner: string, _id: BigNumberish): Promise<BigNumber>;

    balanceOfBatch(_owners: string[], _ids: BigNumberish[]): Promise<BigNumber>;

    certificateStorage(arg0: BigNumberish): Promise<BigNumber>;

    claimedBalances(arg0: BigNumberish, arg1: string): Promise<BigNumber>;

    create(
      _initialSupply: BigNumberish,
      _uri: string,
      creator: string
    ): Promise<BigNumber>;

    creators(arg0: BigNumberish): Promise<BigNumber>;

    initialize(): Promise<BigNumber>;

    isApprovedForAll(_owner: string, _operator: string): Promise<BigNumber>;

    mint(
      _id: BigNumberish,
      _to: string,
      _quantity: BigNumberish
    ): Promise<BigNumber>;

    nonce(): Promise<BigNumber>;

    safeBatchTransferFrom(
      _from: string,
      _to: string,
      _ids: BigNumberish[],
      _values: BigNumberish[],
      _data: Arrayish
    ): Promise<BigNumber>;

    safeTransferFrom(
      _from: string,
      _to: string,
      _id: BigNumberish,
      _value: BigNumberish,
      _data: Arrayish
    ): Promise<BigNumber>;

    setApprovalForAll(
      _operator: string,
      _approved: boolean
    ): Promise<BigNumber>;

    setURI(_uri: string, _id: BigNumberish): Promise<BigNumber>;

    supportsInterface(_interfaceId: Arrayish): Promise<BigNumber>;

    issue(
      _to: string,
      _validityData: Arrayish,
      _topic: BigNumberish,
      _value: BigNumberish,
      _data: Arrayish
    ): Promise<BigNumber>;

    safeTransferAndClaimFrom(
      _from: string,
      _to: string,
      _id: BigNumberish,
      _value: BigNumberish,
      _data: Arrayish,
      _claimData: Arrayish
    ): Promise<BigNumber>;

    safeBatchTransferAndClaimFrom(
      _from: string,
      _to: string,
      _ids: BigNumberish[],
      _values: BigNumberish[],
      _data: Arrayish,
      _claimData: Arrayish[]
    ): Promise<BigNumber>;

    getCertificate(_id: BigNumberish): Promise<BigNumber>;

    claimedBalanceOf(_owner: string, _id: BigNumberish): Promise<BigNumber>;

    totalSupply(): Promise<BigNumber>;

    allCertificateIds(): Promise<BigNumber>;
  };
}
